diff -uNrw asterisk-1.8.19.0/main/utils.c asterisk-1.8.20.0-rc1/main/utils.c
--- asterisk-1.8.19.0/main/utils.c	2012-08-27 15:43:23.000000000 +0200
+++ asterisk-1.8.20.0-rc1/main/utils.c	2012-11-18 21:11:18.000000000 +0100
@@ -29,7 +29,7 @@
 
 #include "asterisk.h"
 
-ASTERISK_FILE_VERSION(__FILE__, "$Revision: 371690 $")
+ASTERISK_FILE_VERSION(__FILE__, "$Revision: 376428 $")
 
 #include <ctype.h>
 #include <sys/stat.h>
@@ -981,18 +981,7 @@
 #ifdef DEBUG_THREADS
 	struct thr_lock_info *lock_info;
 	pthread_mutexattr_t mutex_attr;
-#endif
-
-	/* note that even though data->name is a pointer to allocated memory,
-	   we are not freeing it here because ast_register_thread is going to
-	   keep a copy of the pointer and then ast_unregister_thread will
-	   free the memory
-	*/
-	ast_free(data);
-	ast_register_thread(a.name);
-	pthread_cleanup_push(ast_unregister_thread, (void *) pthread_self());
 
-#ifdef DEBUG_THREADS
 	if (!(lock_info = ast_threadstorage_get(&thread_lock_info, sizeof(*lock_info))))
 		return NULL;
 
@@ -1009,6 +998,15 @@
 	pthread_mutex_unlock(&lock_infos_lock.mutex); /* Intentionally not the wrapper */
 #endif /* DEBUG_THREADS */
 
+	/* note that even though data->name is a pointer to allocated memory,
+	   we are not freeing it here because ast_register_thread is going to
+	   keep a copy of the pointer and then ast_unregister_thread will
+	   free the memory
+	*/
+	ast_free(data);
+	ast_register_thread(a.name);
+	pthread_cleanup_push(ast_unregister_thread, (void *) pthread_self());
+
 	ret = a.start_routine(a.data);
 
 	pthread_cleanup_pop(1);
@@ -1432,6 +1430,23 @@
 	}
 	return a;
 }
+
+int ast_remaining_ms(struct timeval start, int max_ms)
+{
+	int ms;
+
+	if (max_ms < 0) {
+		ms = max_ms;
+	} else {
+		ms = max_ms - ast_tvdiff_ms(ast_tvnow(), start);
+		if (ms < 0) {
+			ms = 0;
+		}
+	}
+
+	return ms;
+}
+
 #undef ONE_MILLION
 
 /*! \brief glibc puts a lock inside random(3), so that the results are thread-safe.
@@ -2137,3 +2152,35 @@
 	return NULL;
 }
 
+void ast_do_crash(void)
+{
+#if defined(DO_CRASH)
+	abort();
+	/*
+	 * Just in case abort() doesn't work or something else super
+	 * silly, and for Qwell's amusement.
+	 */
+	*((int *) 0) = 0;
+#endif	/* defined(DO_CRASH) */
+}
+
+#if defined(AST_DEVMODE)
+void __ast_assert_failed(int condition, const char *condition_str, const char *file, int line, const char *function)
+{
+	/*
+	 * Attempt to put it into the logger, but hope that at least
+	 * someone saw the message on stderr ...
+	 */
+	ast_log(__LOG_ERROR, file, line, function, "FRACK!, Failed assertion %s (%d)\n",
+		condition_str, condition);
+	fprintf(stderr, "FRACK!, Failed assertion %s (%d) at line %d in %s of %s\n",
+		condition_str, condition, line, function, file);
+	/*
+	 * Give the logger a chance to get the message out, just in case
+	 * we abort(), or Asterisk crashes due to whatever problem just
+	 * happened after we exit ast_assert().
+	 */
+	usleep(1);
+	ast_do_crash();
+}
+#endif	/* defined(AST_DEVMODE) */
diff -uNrw asterisk-1.8.19.0/main/xmldoc.c asterisk-1.8.20.0-rc1/main/xmldoc.c
--- asterisk-1.8.19.0/main/xmldoc.c	2012-11-04 01:54:19.000000000 +0100
+++ asterisk-1.8.20.0-rc1/main/xmldoc.c	2012-12-10 02:38:52.000000000 +0100
@@ -29,7 +29,7 @@
 
 #include "asterisk.h"
 
-ASTERISK_FILE_VERSION(__FILE__, "$Revision: 375758 $")
+ASTERISK_FILE_VERSION(__FILE__, "$Revision: 377509 $")
 
 #include "asterisk/_private.h"
 #include "asterisk/paths.h"
@@ -354,7 +354,13 @@
 
 			/* Setup color */
 			if (withcolors) {
-				ast_term_color_code(&colorized, colorized_tags[c].colorfg, 0);
+				if (ast_opt_light_background) {
+					/* Turn off *bright* colors */
+					ast_term_color_code(&colorized, colorized_tags[c].colorfg & 0x7f, 0);
+				} else {
+					/* Turn on *bright* colors */
+					ast_term_color_code(&colorized, colorized_tags[c].colorfg | 0x80, 0);
+				}
 				if (!colorized) {
 					return NULL;
 				}
diff -uNrw asterisk-1.8.19.0/pbx/pbx_dundi.c asterisk-1.8.20.0-rc1/pbx/pbx_dundi.c
--- asterisk-1.8.19.0/pbx/pbx_dundi.c	2012-09-06 04:48:58.000000000 +0200
+++ asterisk-1.8.20.0-rc1/pbx/pbx_dundi.c	2012-11-27 21:32:31.000000000 +0100
@@ -29,7 +29,7 @@
 
 #include "asterisk.h"
 
-ASTERISK_FILE_VERSION(__FILE__, "$Revision: 372417 $")
+ASTERISK_FILE_VERSION(__FILE__, "$Revision: 376657 $")
 
 #include "asterisk/network.h"
 #include <sys/ioctl.h>
@@ -3886,7 +3886,6 @@
 {
 	int results;
 	int x;
-	struct ast_module_user *u;
 	struct dundi_result dr[MAX_RESULTS];
 	AST_DECLARE_APP_ARGS(args,
 		AST_APP_ARG(number);
@@ -3903,8 +3902,6 @@
 		return -1;
 	}
 
-	u = ast_module_user_add(chan);
-
 	parse = ast_strdupa(num);
 
 	AST_STANDARD_APP_ARGS(args, parse);
@@ -3927,8 +3924,6 @@
 		}
 	}
 
-	ast_module_user_remove(u);
-
 	return 0;
 }
 
@@ -3967,7 +3962,6 @@
 
 static int dundi_query_read(struct ast_channel *chan, const char *cmd, char *data, char *buf, size_t len)
 {
-	struct ast_module_user *u;
 	AST_DECLARE_APP_ARGS(args,
 		AST_APP_ARG(number);
 		AST_APP_ARG(context);
@@ -3978,17 +3972,13 @@
 	struct dundi_result_datastore *drds;
 	struct ast_datastore *datastore;
 
-	u = ast_module_user_add(chan);
-
 	if (ast_strlen_zero(data)) {
 		ast_log(LOG_WARNING, "DUNDIQUERY requires an argument (number)\n");
-		ast_module_user_remove(u);
 		return -1;
 	}
 
 	if (!chan) {
 		ast_log(LOG_ERROR, "DUNDIQUERY can not be used without a channel!\n");
-		ast_module_user_remove(u);
 		return -1;
 	}
 
@@ -4003,7 +3993,6 @@
 		args.context = "e164";
 
 	if (!(drds = ast_calloc(1, sizeof(*drds)))) {
-		ast_module_user_remove(u);
 		return -1;
 	}
 
@@ -4012,7 +4001,6 @@
 
 	if (!(datastore = ast_datastore_alloc(&dundi_result_datastore_info, buf))) {
 		drds_destroy(drds);
-		ast_module_user_remove(u);
 		return -1;
 	}
 
@@ -4028,8 +4016,6 @@
 	ast_channel_datastore_add(chan, datastore);
 	ast_channel_unlock(chan);
 
-	ast_module_user_remove(u);
-
 	return 0;
 }
 
@@ -4040,7 +4026,6 @@
 
 static int dundi_result_read(struct ast_channel *chan, const char *cmd, char *data, char *buf, size_t len)
 {
-	struct ast_module_user *u;
 	AST_DECLARE_APP_ARGS(args,
 		AST_APP_ARG(id);
 		AST_APP_ARG(resultnum);
@@ -4051,8 +4036,6 @@
 	struct ast_datastore *datastore;
 	int res = -1;
 
-	u = ast_module_user_add(chan);
-
 	if (ast_strlen_zero(data)) {
 		ast_log(LOG_WARNING, "DUNDIRESULT requires an argument (id and resultnum)\n");
 		goto finish;
@@ -4107,8 +4090,6 @@
 		ast_log(LOG_WARNING, "Result number %u is not valid for DUNDi query results for ID %s!\n", num, args.id);
 
 finish:
-	ast_module_user_remove(u);
-
 	return res;
 }
 
@@ -4776,7 +4757,12 @@
 static int unload_module(void)
 {
 	pthread_t previous_netthreadid = netthreadid, previous_precachethreadid = precachethreadid, previous_clearcachethreadid = clearcachethreadid;
-	ast_module_user_hangup_all();
+
+	ast_cli_unregister_multiple(cli_dundi, ARRAY_LEN(cli_dundi));
+	ast_unregister_switch(&dundi_switch);
+	ast_custom_function_unregister(&dundi_function);
+	ast_custom_function_unregister(&dundi_query_function);
+	ast_custom_function_unregister(&dundi_result_function);
 
 	/* Stop all currently running threads */
 	dundi_shutdown = 1;
@@ -4793,11 +4779,6 @@
  		pthread_join(previous_clearcachethreadid, NULL);
  	}
 
-	ast_cli_unregister_multiple(cli_dundi, ARRAY_LEN(cli_dundi));
-	ast_unregister_switch(&dundi_switch);
-	ast_custom_function_unregister(&dundi_function);
-	ast_custom_function_unregister(&dundi_query_function);
-	ast_custom_function_unregister(&dundi_result_function);
 	close(netsocket);
 	io_context_destroy(io);
 	sched_context_destroy(sched);
diff -uNrw asterisk-1.8.19.0/pbx/pbx_spool.c asterisk-1.8.20.0-rc1/pbx/pbx_spool.c
--- asterisk-1.8.19.0/pbx/pbx_spool.c	2012-10-08 22:45:25.000000000 +0200
+++ asterisk-1.8.20.0-rc1/pbx/pbx_spool.c	2012-11-14 20:48:13.000000000 +0100
@@ -28,7 +28,7 @@
 
 #include "asterisk.h"
 
-ASTERISK_FILE_VERSION(__FILE__, "$Revision: 374686 $")
+ASTERISK_FILE_VERSION(__FILE__, "$Revision: 376232 $")
 
 #include <sys/stat.h>
 #include <time.h>
@@ -492,7 +492,7 @@
 	int res;
 	time_t now = time(NULL);
 
-	if (filename[0] != '/') {
+	if (!strchr(filename, '/')) {
 		char *fn = ast_alloca(strlen(qdir) + strlen(filename) + 2);
 		sprintf(fn, "%s/%s", qdir, filename); /* SAFE */
 		filename = fn;
diff -uNrw asterisk-1.8.19.0/.version asterisk-1.8.20.0-rc1/.version
--- asterisk-1.8.19.0/.version	2012-12-10 01:49:02.000000000 +0100
+++ asterisk-1.8.20.0-rc1/.version	2012-12-10 02:48:00.000000000 +0100
@@ -1 +1 @@
-1.8.19.0
+1.8.20.0-rc1
